from qai_hub_models.models._shared.imagenet_classifier.test_utils import (
    run_imagenet_classifier_test,
    run_imagenet_classifier_trace_test,
)
from qai_hub_models.models.resnet18.demo import main as demo_main
from qai_hub_models.models.resnet18.model import MODEL_ID, ResNet18


def test_task():
    run_imagenet_classifier_test(
        ResNet18.from_pretrained(),
        MODEL_ID,
        probability_threshold=0.45,
        diff_tol=0.005,
        atol=0.02,
        rtol=0.2,
    )


def test_trace():
    run_imagenet_classifier_trace_test(ResNet18.from_pretrained())


def test_demo():
    # Verify demo does not crash
    demo_main(is_test=True)
